/*
	Speccy Tracks Remake!

	Freezing by Spectra
	- Adapted from my first lua for kart euphorica.
	- Mostly Copypasted from my Chaoskart mod.
*/

// Thinkframe
addHook("ThinkFrame", function()
	for p in players.iterate do
		if p.mo and p.mo.valid then
			if p.mo.frozen then
				p.freezeangle = $ or p.mo.angle

				p.mo.color = SKINCOLOR_JAWZ
				p.mo.colorized = true
				p.mo.angle = p.freezeangle
				p.mo.friction = FRACUNIT

				p.kartstuff[k_spinouttimer] = 2
				p.kartstuff[k_wipeoutslow] = 0
				p.kartstuff[k_offroad] = 0
				p.kartstuff[k_boostpower] = min($, FRACUNIT/6)

				p.mo.frozen = $-1

				local mash = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + P_GetPlayerHeight(p), MT_MASH)
				mash.frame = (leveltime%10)/3
				mash.tics = 1

				if p.buttons.drift == 1 or p.buttons.accelerate == 1 or p.buttons.attack == 1 or p.buttons.brake == 1 then
					S_StartSound(p.mo, sfx_s3k94)
					p.mo.frozen = $-10

					local debris = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SMK_ICEBLOCK_DEBRIS)
					debris.angle = FixedAngle(P_RandomRange(0,360)<<FRACBITS)
					P_InstaThrust(debris, debris.angle, P_RandomRange(3,18)*(FRACUNIT/4))
					debris.momz = P_RandomRange(4,8)<<FRACBITS
				end

				if p.mo.frozen <= 0 then
					S_StartSound(p.mo, sfx_s3k82)
					p.mo.angle = $
					p.mo.colorized = false
					p.mo.color = p.skincolor
					p.mo.frozen = nil
					p.freezeangle = nil

					local debris
					for i = 1, 20 do
						debris = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_SMK_ICEBLOCK_DEBRIS)
						debris.angle = FixedAngle(P_RandomRange(0,360)<<FRACBITS)
						P_InstaThrust(debris, debris.angle, P_RandomRange(3,18)*(FRACUNIT/4))
						debris.momz = P_RandomRange(4,8)<<FRACBITS
					end
				end
			end
		end
	end
end)