/*
	Speccy Tracks Remake!
	
	Propeller by Spectra
	- Adapted from my first lua for kart euphorica.
*/

freeslot("MT_RACERPROPELLER", "S_RACERPROPELLER")

mobjinfo[MT_RACERPROPELLER] = {
	spawnstate = S_RACERPROPELLER,
	flags = MF_SCENERY|MF_NOBLOCKMAP|MF_NOGRAVITY,
}
states[S_RACERPROPELLER] = {SPR_PRPL, A, 1, nil, 0, 0, S_NULL}

local propeller
K_AddPThink(function(p)
	if (p.mo.eflags & MFE_UNDERWATER) and not (p.mo.state == S_INVISIBLE) and not (p.mo.flags2 & MF2_DONTDRAW) and not (p.mo.frame == R) and not (gametype == GT_BATTLE and (p.kartstuff[k_comebacktimer] != 0) and (p.kartstuff[k_bumper] < 1))
		propeller = P_SpawnMobj(p.mo.x - 20*cos(p.frameangle),  p.mo.y - 20*sin(p.frameangle), p.mo.z, MT_RACERPROPELLER)
		propeller.sprite = SPR_PRPL
		propeller.angle = p.frameangle+ANGLE_180
		propeller.frame = (leveltime/4 % F)|FF_FULLBRIGHT
		propeller.tics = 1
	end
end)
